import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.border.LineBorder;

/**
 * 
 */

class ListRenderer
	extends JLabel
	implements ListCellRenderer
{

	private Font _font;
	private String[] textImage;
	private BufferedImage[] listImage;

	public ListRenderer(int size)
	{
		this.textImage = new String[size];
		this.listImage = new BufferedImage[size];
	}

	public void createBufferedImage(int index, String textImage, BufferedImage bufferedImage)
	{
		this.textImage[index] = textImage;
		this.listImage[index] = bufferedImage;
	}

	/*
     * This method finds the image and text corresponding
     * to the selected value and returns the label, set up
     * to display the text and image.
     */

     public Component getListCellRendererComponent(
    	 JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
     {
     	//Get the selected index. (The index param isn't
     	//always valid, so just use the value.)

     	if(isSelected)
     	{
     		setBackground(list.getSelectionBackground());
     		setForeground(list.getSelectionForeground());
     	}
     	else
     	{
     		setBackground(list.getBackground());
     		setForeground(list.getForeground());
     	}

     	if (isSelected)
     		setBorder(new LineBorder(new Color(0,0,255)));
     	else
     		setBorder(new LineBorder(Color.white));

     	//Set the icon and text.  If icon was null, say so.
     	setText(textImage[index]);
        setIcon(new ImageIcon(listImage[index]));
		return this;
	}
}