
package com.mindfusion.diagramming.samples.demo;


/**
 * Represents a step in the step tree.
 */
public class Step
{
	/**
	 * Initializes a new instance of the Step class.
	 */
	public Step(int key, String name, String info,
		String file, String source, String controlPaneId)
	{
		_key = key;
		_name = name;
		_info = info;
		_file = file;
		_source = source;
		_controlPaneId = controlPaneId;
	}

	/**
	 * Object.toString override.
	 */
	@Override
	public String toString()
	{
		return _name;
	}

	/**
	 * Gets the key associated with the step.
	 */
	public int getKey() { return _key; }

	/**
	 * Gets the name of the step.
	 */
	public String getName() { return _name; }

	/**
	 * Gets the HTML-formatted information associated with the step.
	 */
	public String getInfo() { return _info; }

	/**
	 * Gets the file containing the step sample diagram.
	 */
	public String getFile() { return _file; }

	/**
	 * Gets the HTML-formatted source code associated with the step.
	 */
	public String getSource() { return _source; }

	/**
	 * Gets the key of the associated control panel.
	 */
	public String getControlPaneId() { return _controlPaneId; }


	private int _key;
	private String _name;
	private String _info;
	private String _file;
	private String _source;
	private String _controlPaneId;
}
