import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

import javax.swing.*;
import javax.swing.event.*;

import com.mindfusion.diagramming.AdjustmentHandles;
import com.mindfusion.diagramming.AnchorPattern;
import com.mindfusion.diagramming.ArrowHeads;
import com.mindfusion.diagramming.Behavior;
import com.mindfusion.diagramming.CellFrameStyle;
import com.mindfusion.diagramming.Column;
import com.mindfusion.diagramming.ColumnStyle;
import com.mindfusion.diagramming.DiagramAdapter;
import com.mindfusion.diagramming.DiagramItem;
import com.mindfusion.diagramming.DiagramLink;
import com.mindfusion.diagramming.DiagramNode;
import com.mindfusion.diagramming.DiagramView;
import com.mindfusion.diagramming.GradientBrush;
import com.mindfusion.diagramming.HandlesStyle;
import com.mindfusion.diagramming.ImageAlign;
import com.mindfusion.diagramming.LinkEvent;
import com.mindfusion.diagramming.LinkShape;
import com.mindfusion.diagramming.NodeEvent;
import com.mindfusion.diagramming.Pen;
import com.mindfusion.diagramming.SelectionStyle;
import com.mindfusion.diagramming.ShadowsStyle;
import com.mindfusion.diagramming.ShapeNode;
import com.mindfusion.diagramming.SnapToAnchor;
import com.mindfusion.diagramming.SolidBrush;
import com.mindfusion.diagramming.TableConnectionStyle;
import com.mindfusion.diagramming.TableNode;
import com.mindfusion.diagramming.jlayout.Orientation;

import java.io.*;

public class DiagramForm extends JInternalFrame
{
	static int openFrameCount = 0;
    static final int xOffset = 30, yOffset = 30;

	private JPanel _pnlTools;
	private JButton _btnNewClass;
	private JComboBox _cbZoom;
	private JButton _btnDelete;
	private JButton _btnNewIface;
	private JButton _btnNewEnum;
	private JButton _btnDerive;
	private JButton _btnCompose;
	private JButton _btnLinkNotation;
	private JButton _btnNotation;
	private com.mindfusion.diagramming.Diagram diag;
	private DiagramView diagView;
	private JPopupMenu _cmenu;
	private JMenuItem _menuUp;
	private JMenuItem _menuDown;
	private JMenuItem _menuDelete;
	private JMenuItem _menuSep;
	private JMenuItem _menuInsert;
	private JScrollPane _scrPane;
	private JPanel _chartPanel;

	private Font _fntIface;
	private Font _fntEnum;
	private Font _fntClass;
	private Font _fntNote;

	public DiagramForm()
	{


		super("",
              true, //resizable
              true, //closable
              true, //maximizable
              true);
		super.addInternalFrameListener(new InternalFrameAdapter(){
			public void internalFrameClosed(InternalFrameEvent e){
				diagramForm_Closing();
			}
		});

		_pnlTools = new JPanel();
		_cbZoom = new JComboBox();

		_btnNewClass = new JButton();
		_btnNewIface = new JButton();
		_btnNewEnum = new JButton();
		_btnNotation = new JButton();

		_btnDelete = new JButton();

		_btnDerive = new JButton();
		_btnCompose = new JButton();
		_btnLinkNotation = new JButton();

		_cmenu = new JPopupMenu();
		_menuUp = new JMenuItem();
		_menuDown = new JMenuItem();
		_menuDelete = new JMenuItem();
		_menuSep = new JMenuItem();
		_menuInsert = new JMenuItem();

		_chartPanel = new JPanel();

		diag = new com.mindfusion.diagramming.Diagram();
		diagView = new DiagramView(diag);
		_scrPane = new JScrollPane(diagView);


		ImageIcon _imageEnum = this.createImageIcon("Icons/Enum.jpg");
		ImageIcon _imageIface = this.createImageIcon("Icons/Iface.jpg");
		ImageIcon _imageMethod = this.createImageIcon("Icons/Method.jpg");
		ImageIcon _imageNotation = this.createImageIcon("Icons/Notation.jpg");
		ImageIcon _imageNotationLink = this.createImageIcon("Icons/NotationLink.jpg");
		ImageIcon _imageProperty = this.createImageIcon("Icons/Property.jpg");
		ImageIcon _imageClass = this.createImageIcon("Icons/Class.jpg");
		ImageIcon _imageCompositionLink = this.createImageIcon("Icons/Composition.jpg");
		ImageIcon _imageDelete = this.createImageIcon("Icons/Delete.jpg");
		ImageIcon _imageDeriveLink = this.createImageIcon("Icons/Derive.jpg");


		JLabel emptyLabel = new JLabel();
		emptyLabel.setPreferredSize(new Dimension(10, 21));

		JLabel emptyLabel2 = new JLabel();
		emptyLabel2.setPreferredSize(new Dimension(5, 21));

		JLabel emptyLabel3 = new JLabel();
		emptyLabel3.setPreferredSize(new Dimension(5, 21));


		_fntClass = new Font("Arial", Font.PLAIN, 4);
        _fntIface = new Font("Arial", Font.ITALIC, 4);
        _fntEnum = new Font("Arial", Font.BOLD, 4);
        _fntNote = new Font("Arial", Font.BOLD, 4);

        diag.setShowDisabledHandles(false);
        diag.getSelection().setHandlesStyle(SelectionStyle.SemiTransparent);
		//
		// diag
		//
		diagView.setAllowInplaceEdit(true);
		diagView.setBehavior(Behavior.DrawLinks);
		diag.setAllowLinksRepeat(false);
		diag.setAllowSelfLoops(true);
		diag.getDiagramLinkStyle().setBrush(new SolidBrush(Color.white));
		diag.setLinkCascadeOrientation(Orientation.Vertical);
		diag.setLinkHeadShape(ArrowHeads.RevTriangle);
		diag.setLinkShape(LinkShape.Cascading);
		diag.setLinkSegments((short)3);
		diag.setBackBrush(new SolidBrush(new Color(245, 245, 255)));
		diag.setBackgroundImageAlign(ImageAlign.Tile);
		diag.setDefaultShape(com.mindfusion.diagramming.Shape.fromId("Rectangle"));
		diag.setCellFrameStyle(CellFrameStyle.None);
		diag.getDisabledHandlesStyle().setHandleBrush(new SolidBrush(Color.white));
		diag.setDynamicLinks(true);
		diag.setSelectAfterCreate(false);
		diag.setShadowOffsetX(4);
		diag.setShadowOffsetY(4);
		diag.setShadowsStyle(ShadowsStyle.None);
		diag.setSnapToAnchor(SnapToAnchor.OnCreateOrModify);
		diag.setTableCaption("");
		diag.setTableCaptionHeight(6);
		diag.setTableColumnCount(1);
		diag.setTableHandlesStyle(HandlesStyle.HatchHandles3);
		diag.setTableConnectionStyle(TableConnectionStyle.Table);
		diag.setTableRowCount(0);
		diag.addDiagramListener(new DiagramAdapter()
		{
			public void linkDeleted(LinkEvent e)
			{
				onDeleteArrow(e);
			}

			public void nodeClicked(NodeEvent e)
			{
				if(e.getNode() instanceof TableNode){
					onTableClicked(e);
				}
			}
			
			public void linkCreated(LinkEvent e)
			{
				onCreateArrow(e);
			}

		});

		//
		// _pnlTools
		//
		_pnlTools.setName("_pnlTools");
		_pnlTools.setPreferredSize(new Dimension(340, 30));
		_pnlTools.setLayout(new FlowLayout());
		_pnlTools.add(_cbZoom);

		_pnlTools.add(emptyLabel);
		_pnlTools.add(_btnNewClass);
		_pnlTools.add(_btnNewIface);
		_pnlTools.add(_btnNewEnum);
		_pnlTools.add(_btnNotation);

		_pnlTools.add(emptyLabel2);
		_pnlTools.add(_btnDelete);

		_pnlTools.add(emptyLabel3);
		_pnlTools.add(_btnDerive);
		_pnlTools.add(_btnCompose);
		_pnlTools.add(_btnLinkNotation);


		//
		//_scrPane
		//
		_scrPane.setName("_scrPane");
		_scrPane.setAutoscrolls(true);


		//
		// _chartPanel
		//

		_chartPanel.setName("_chartPanel");
		_chartPanel.setLayout(new BoxLayout(_chartPanel, BoxLayout.Y_AXIS));
		_chartPanel.add(_scrPane);




		String[] model = {"10", "25", "50", "100", "150"};
		DefaultComboBoxModel _cmbModel = new DefaultComboBoxModel(model);
		//
		// _cbZoom
		//
		_cbZoom.setName("_cbZoom");
		_cbZoom.setModel(_cmbModel);
		_cbZoom.setSelectedIndex(3);
		_cbZoom.setPreferredSize(new Dimension(80, 21));
		_cbZoom.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_cbZoomSelected();
			}
		});

		//
		// _btnNewClass
		//
		_btnNewClass.setName("_btnNewClass");
		_btnNewClass.setToolTipText("New class");
		_btnNewClass.setIcon(_imageClass);
		_btnNewClass.setPreferredSize(new Dimension(21, 21));
		_btnNewClass.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnClass_Click();
			}
		});

		//
		// _btnNewIface
		//
		_btnNewIface.setName("_btnNewIface");
		_btnNewIface.setIcon(_imageIface);
		_btnNewIface.setToolTipText("New interface");
		_btnNewIface.setPreferredSize(new Dimension(21, 21));
		_btnNewIface.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnIface_Click();
			}
		});

		//
		// _btnNewEnum
		//
		_btnNewEnum.setName("_btnNewEnum");
		_btnNewEnum.setIcon(_imageEnum);
		_btnNewEnum.setToolTipText("New enum");
		_btnNewEnum.setPreferredSize(new Dimension(21, 21));
		_btnNewEnum.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnEnum_Click();
			}
		});

		//
		// _btnNotation
		//
		_btnNotation.setName("_btnNotation");
		_btnNotation.setIcon(_imageNotation);
		_btnNotation.setToolTipText("New annotation");
		_btnNotation.setPreferredSize(new Dimension(21, 21));
		_btnNotation.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnNotation_Click();
			}
		});

		//
		// _btnDelete
		//
		_btnDelete.setName("_btnDelete");
		_btnDelete.setIcon(_imageDelete);
		_btnDelete.setToolTipText("New annotation");
		_btnDelete.setPreferredSize(new Dimension(21, 21));
		_btnDelete.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnDelete_Click();
			}
		});


		//
		// _btnDerive
		//
		_btnDerive.setName("_btnDerive");
		_btnDerive.setIcon(_imageDeriveLink);
		_btnDerive.setToolTipText("Derive link");
		_btnDerive.setPreferredSize(new Dimension(21, 21));
		_btnDerive.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnDerive_Click();
			}
		});

		//
		// _btnCompose
		//
		_btnCompose.setName("_btnCompose");
		_btnCompose.setIcon(_imageCompositionLink);
		_btnCompose.setToolTipText("Composition link");
		_btnCompose.setPreferredSize(new Dimension(21, 21));
		_btnCompose.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnCompose_Click();
			}
		});

		//
		// _btnLinkNotation
		//
		_btnLinkNotation.setName("_btnLinkNotation");
		_btnLinkNotation.setIcon(_imageNotationLink);
		_btnLinkNotation.setToolTipText("Annotation link");
		_btnLinkNotation.setPreferredSize(new Dimension(21, 21));
		_btnLinkNotation.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnLinkNotation_Click();
			}
		});

		//
		// _cmenu
		//
		_cmenu.setName("_cmenu");
		_cmenu.add(_menuInsert);
		_cmenu.add(_menuDelete);
		_cmenu.addSeparator();
		_cmenu.add(_menuUp);
		_cmenu.add(_menuDown);

		//
		// _menuUp
		//
		_menuUp.setName("_menuUp");
		_menuUp.setText("Up");
		_menuUp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnUpPopup();
			}
		});

		//
		// _menuDown
		//
		_menuDown.setName("_menuDown");
		_menuDown.setText("Down");
		_menuDown.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnDownPopup();
			}
		});

		//
		// _menuDelete
		//
		_menuDelete.setName("_menuDelete");
		_menuDelete.setText("Delete");
		_menuDelete.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnDeletePopup();
			}
		});

		//
		// _menuInsert
		//
		_menuInsert.setName("_menuInsert");
		_menuInsert.setText("Insert");
		_menuInsert.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				_btnInsertPopup();
			}
		});





		//
		// create ContentPane
		//
		Container cp = getContentPane();
		cp.setLayout(null);
		cp.add(_pnlTools);
		cp.add(_chartPanel);


		javax.swing.SpringLayout sprLayout = new javax.swing.SpringLayout();

		sprLayout.putConstraint(javax.swing.SpringLayout.NORTH, _pnlTools, 0,
									javax.swing.SpringLayout.NORTH,	cp);
		sprLayout.putConstraint(javax.swing.SpringLayout.SOUTH, _chartPanel, 0,
									javax.swing.SpringLayout.SOUTH,	_pnlTools);

		sprLayout.putConstraint(javax.swing.SpringLayout.NORTH,_chartPanel, 30,
									javax.swing.SpringLayout.NORTH, cp);
		sprLayout.putConstraint(javax.swing.SpringLayout.WEST, _chartPanel, 0,
									javax.swing.SpringLayout.WEST, cp);
		sprLayout.putConstraint(javax.swing.SpringLayout.EAST,cp , 0,
									javax.swing.SpringLayout.EAST,	_chartPanel);
		sprLayout.putConstraint(javax.swing.SpringLayout.SOUTH, _chartPanel, 0,
									javax.swing.SpringLayout.SOUTH,	cp);


		cp.setLayout(sprLayout);

		setSize(350, 300);
		setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
		openFrameCount++;

	}


	protected static ImageIcon createImageIcon(String path) {
	    java.net.URL imgURL = DiagramForm.class.getResource(path);


	    if (imgURL != null) {
	        return new ImageIcon(imgURL);
	    } else {
	        System.err.println("Couldn't find file: " + path);
	        return null;
	    }
	}

	public void diagramForm_Closing()
	{
		Save();
	}

	public void _cbZoomSelected()
	{
		float[] zooms = new float[] { 10, 25, 50, 100, 150 };
		if(_cbZoom.getSelectedIndex() == -1)
			return;

		diagView.setZoomFactor(zooms[_cbZoom.getSelectedIndex()]);
		diag.setAutoResize(15);
	}

	public void _btnClass_Click()
	{
		TableNode t = diag.getFactory().createTableNode(10, 10, 40, diag.getTableCaptionHeight() + 1);

		t.setFont(_fntClass);
		t.setCaption("Class");
		t.setAnchorPattern(AnchorPattern.fromId("TopInBottomOut"));
		t.setEnabledHandles(AdjustmentHandles.Move);

		for(Column col : t.getColumns())
		{
			col.setColumnStyle(ColumnStyle.AutoWidth);
		}
	}

	public void _btnIface_Click()
	{
		TableNode t = diag.getFactory().createTableNode(10, 10, 40, diag.getTableCaptionHeight() + 1);

		t.setFont(_fntIface);
		t.setCaption("Interface");
		t.setAnchorPattern(AnchorPattern.fromId("TopInBottomOut"));
		t.setBrush(new SolidBrush(new Color( 176, 196, 222)));
		t.setEnabledHandles(AdjustmentHandles.Move);

		for(Column col : t.getColumns())
		{
			col.setColumnStyle(ColumnStyle.AutoWidth);
		}

	}

	public void _btnEnum_Click()
	{
		TableNode t = diag.getFactory().createTableNode(10, 10, 40, diag.getTableCaptionHeight() + 1);

		t.setFont(_fntEnum);
		t.setCaption("enum");
		t.setBrush(new SolidBrush(new Color( 238, 232, 170)));
		t.setEnabledHandles(AdjustmentHandles.Move);

		for(Column col : t.getColumns())
		{
			col.setColumnStyle(ColumnStyle.AutoWidth);
		}
	}

	public void _btnNotation_Click()
	{

		ShapeNode b = diag.getFactory().createShapeNode(10, 10, 25, 26);

		b.setFont(_fntNote);
		b.setBrush(new GradientBrush( Color.white, new Color(152, 251, 152),30));
		b.setText("<note>");
		b.setPen(new Pen(0, Color.black));
	}

	public void _btnDelete_Click()
	{
		if(diag.getSelection() != null)
		{
			
			if (!diag.getSelection().getNodes().isEmpty())
				diag.getNodes().retainAll(diag.getSelection().getNodes());

			if (!diag.getSelection().getLinks().isEmpty())
				diag.getLinks().remove(diag.getSelection().getLinks());
		}
	}

	public void _btnDerive_Click()
	{
		diag.setLinkHeadShape(ArrowHeads.RevTriangle);
		diag.setLinkShape(LinkShape.Cascading);
		diag.setLinkSegments((short)3);
		diag.setLinkCascadeOrientation(Orientation.Horizontal);
	}

	public void _btnCompose_Click()
	{
		diag.setLinkHeadShape(ArrowHeads.Rhombus);
		diag.setLinkShape(LinkShape.Cascading);
		diag.setLinkSegments((short)3);
		diag.setLinkCascadeOrientation(Orientation.Horizontal);
	}

	public void _btnLinkNotation_Click()
	{
		diag.setLinkHeadShape(ArrowHeads.None);
		diag.setLinkShape(LinkShape.Polyline);
		diag.setLinkSegments((short)1);
	}

	public void _btnUpPopup()
	{
		if( clickedRow > 0)
		{
			String text = clickedTable.getCell(0, clickedRow).getText();
			clickedTable.getCell(0, clickedRow).setText(clickedTable.getCell(0, clickedRow - 1).getText());
			clickedTable.getCell(0, clickedRow - 1).setText(text);

		}
	}

	public void _btnDownPopup()
	{
		if( clickedRow < clickedTable.getRowCount() - 1 && clickedRow > -1)
		{

			String text = clickedTable.getCell(0, clickedRow).getText();
			clickedTable.getCell(0, clickedRow).setText(clickedTable.getCell(0, clickedRow + 1).getText());
			clickedTable.getCell(0, clickedRow + 1).setText(text);
		}
	}

	public void _btnDeletePopup()
	{
		if(clickedRow >= clickedTable.getRowCount())
			return;

		else if(clickedRow >= 0)
		{
			clickedTable.deleteRow(clickedRow);

			Rectangle.Float rc = clickedTable.getBounds();
			double height = rc.getHeight();
			height -= clickedTable.getRowHeight();
			rc.setRect( rc.getX(), rc.getY(), rc.getWidth(),height );
			clickedTable.setBounds(rc);
		}

	}

	public void _btnInsertPopup()
	{

		clickedTable.insertRow(clickedRow);
		clickedTable.getCell(0, clickedRow).setText("<item>");

		Rectangle.Float _rc = clickedTable.getBounds();
		double height = _rc.getHeight() + clickedTable.getRowHeight();
		_rc.setRect(_rc.getX(), _rc.getY(), _rc.getWidth(), height);
		clickedTable.setBounds(_rc);
	}

	public Diagram getDiagram(){
		return diagram;
	}

	public void setDiagram(Diagram d)
		throws FileNotFoundException
	{
		diagram = d;

		if(diagram.getData().compareTo("") != 0){
			diag.loadFromString(diagram.getData());
		}


		String s = Float.toString(diagView.getZoomFactor());
		for (int i = 0; i < _cbZoom.getModel().getSize(); i++)
		{
			if (_cbZoom.getModel().getSelectedItem().toString().compareTo(s) == 0)
			{
				_cbZoom.setSelectedIndex(i);
				break;
			}
		}
	}

	//
	//Save the Diagram
	//
	public void Save()
	{
		if(diag.getDirty() && (diagram != null))
		{
			diagram.setData(diag.saveToString());

		}
	}

	public void onTableClicked(NodeEvent e)
	{
		TableNode table = e.getNode() instanceof TableNode ?
				(TableNode)e.getNode() : null;

		if (e.getMouseButton() == MouseEvent.BUTTON3 && table != null)
		{
			clickedTable = table;
			Point cellPos = new Point(-1, -1);

			if (table.cellFromPoint(e.getMousePosition(), cellPos))
			{
				clickedRow = cellPos.y;
				if (clickedRow < 0)
					clickedRow = clickedTable.getRowCount();
			}
			else
			{
				clickedRow = clickedTable.getRowCount();
			}
			
			// display context menu at right mouse click
			Point mousePos = getMousePosition();
			_cmenu.show(this, mousePos.x, mousePos.y);
		}
	}

	public void onCreateArrow(LinkEvent e)
	{
		ShapeNode box = null;
		DiagramItem other = null;
		DiagramLink arrow = null;

		arrow = e.getLink();

		for (DiagramLink a : diag.getLinks())
		{
			arrow = a;
		}

		if (arrow.getOrigin() instanceof ShapeNode)
		{
			box = (ShapeNode)arrow.getOrigin();
			other = arrow.getDestination();
		}

		if (arrow.getDestination() instanceof ShapeNode)
		{
			box = (ShapeNode)arrow.getDestination();
			other = arrow.getDestination();
		}

		if (box != null)
		{
			if(other.getSubordinateGroup() == null)
				diag.getFactory().createGroup(other);
			other.getSubordinateGroup().attachToCorner(box, 0);
		}


	}

	public void onDeleteArrow(LinkEvent e)
	{
		ShapeNode box = null;
		DiagramItem other = null;
		DiagramLink arrow = null;

		arrow = e.getLink();


		if(arrow.getOrigin() instanceof ShapeNode)
		{
			box = (ShapeNode)arrow.getOrigin();
			other = arrow.getDestination();
		}

		if(arrow.getDestination() instanceof ShapeNode)
		{
			box = (ShapeNode)arrow.getDestination();
			other = arrow.getDestination();
		}

		if (box != null)
		{
			if(other.getSubordinateGroup() != null){}
				other.getSubordinateGroup().detach(box);
		}
	}

	public DiagramView getDiag()
	{
		return diagView;
	}

	private Diagram diagram;
	private TableNode clickedTable;
	private int clickedRow = 0;
}